/**
 *
 * PSpice-DMI Model File Auto-generated by PSpice Model Editor
 *
 * TYPICALLY NO MODIFICATION REQUIRED
 *
 * This file contains functions which should typically need no modification from the user.
 */
 
#include "StdAfx.h"
#include <string>
#include <vector>
#include <map>
#include <utility>

#include "pspEngFunc.h"
#include "pspSysCFIR.h"

#include "SysCFIR.h"

pspSysCFIR::pspSysCFIR(const char* pInstName, void*pRef){
	mRef = pRef;
	mInstName = pInstName;
	mPortCount = 33;
	mInputPortCount = 17;

	m_SysCFIR = new SysCFIR(pInstName);
m_SysCFIR->CLK(sysCsig_CLK);
m_SysCFIR->reset(sysCsig_reset);
m_SysCFIR->input(sysCsig_input);
m_SysCFIR->output(sysCsig_output);
 
}

pspSysCFIR::~pspSysCFIR(){
	delete m_SysCFIR;
}



int pspSysCFIR::getDeviceTerminals(void* pVectorPorts){
	PSpicePort* lVectorPorts = (PSpicePort*)pVectorPorts;
	PSpicePort* lPort;

	for (int i = 0; i<mPortCount; i++) {
		lPort = &lVectorPorts[i];
		lPort->mNumber = i;
		if (i<mInputPortCount)
			lPort->mType = PSPICE_PORT_IN;
		else
			lPort->mType = PSPICE_PORT_IO;
	}
	return 0;
}

bool pspSysCFIR::setTermCount(int pTermCount){
	if (mPortCount != pTermCount)
		return false;
	return true;
}


//--------------------Callback Methods--------------------------------------
void* __cdecl pspSysCFIR_CreateDevice(const char* pInstName, void* pRef) {
	return new pspSysCFIR(pInstName, pRef);
}

void __cdecl pspSysCFIR_DeleteDevice(void* pRef) {
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	delete lpspSysCFIR; //release memory
}

void __cdecl pspSysCFIR_InitDevice(void* pRef) {
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	lpspSysCFIR->initialize();
}

bool __cdecl pspSysCFIR_EvaluateDevice(void* pRef, double pTicks, PSpiceState* pVectorStates, int pSize) {
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	return lpspSysCFIR->evaluate(pTicks, pVectorStates, pSize); //issue: what does return value signify
}

int __cdecl pspSysCFIR_GetDeviceTerminals(void* pRef, void* pVectorPorts){
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	return lpspSysCFIR->getDeviceTerminals(pVectorPorts);//issue: what does return value signify
}

void __cdecl pspSysCFIR_SetParameter(void* pRef, PSpiceCMIParam** pVectorParameter, int pParamCount) {
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	lpspSysCFIR->setParameter(pParamCount, pVectorParameter); //issue: what does return value signify
}

int __cdecl pspSysCFIR_GetParameter(void* pRef, void** pVectorParameter) {
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	PSpiceCMIParam** lParam = (PSpiceCMIParam**)pVectorParameter;
	return lpspSysCFIR->getParameter(lParam);
}

bool __cdecl pspSysCFIR_SetTermCount(void* pRef, int pCount) {
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	return lpspSysCFIR->setTermCount(pCount);
}

int __cdecl pspSysCFIR__SetInstanceParams(void* pRef, PSpiceCMIParam** pVectorParameter, int pParamCount) {
	pspSysCFIR* lpspSysCFIR = (pspSysCFIR*)pRef;
	lpspSysCFIR->setParameter(pParamCount, pVectorParameter); //issue: what does return value signify
	return 1;
}

//-------Install Function linking between device and simulator-----------------
void __cdecl installpspSysCFIR(void* pRef) {
	fp_descSetVersion(pRef, "1.2");
	fp_descSetName(pRef, "SysCFIR");
	fp_descSetCreateDevice(pRef, &pspSysCFIR_CreateDevice);
	fp_descSetDeleteDevice(pRef, &pspSysCFIR_DeleteDevice);
	fp_descSetInitDevice(pRef, &pspSysCFIR_InitDevice);
	fp_descSetSetDeviceTermCount(pRef, &pspSysCFIR_SetTermCount);
	fp_descSetEvaluateDevice(pRef, &pspSysCFIR_EvaluateDevice);
	fp_descSetGetDeviceTerminals(pRef, &pspSysCFIR_GetDeviceTerminals);
	fp_descSetSetParameter(pRef, &pspSysCFIR_SetParameter);
	fp_descSetSetInstanceParams(pRef, &pspSysCFIR__SetInstanceParams);
}




