/*
* Copyright by Cadence Design Systems 2015. All rights reserved
*/

#include "StdAfx.h"
#include <string>
#include <vector>
#include <map>
#include <utility>

#include "PSpiceBase.h"
#include "pspEngFunc.h"

extern "C" descSetInstallFunction_t fp_descSetInstallFunction;

extern void installpspNoiseFilter(void* pRef);

CDLL_FUNC void __cdecl  PSpiceInstallFunction() {
	fp_descSetInstallFunction(&installpspNoiseFilter);
}

extern "C" {
	descSetInstallFunction_t fp_descSetInstallFunction = NULL;
	pPSpiceSetSimulationTemperature_t fp_setSimTemp = NULL;
	pPSpiceSetProbeTitle_t fp_descSetProbeTitle = NULL;
	pPSpiceGetCurrentAnalogTime_t fp_getAnalogTime = NULL;
	pPSpiceGetCurrentDigitalTime_t fp_getDigitalTime = NULL; //Digital
	pPSpiceGetParamValue_t fp_GetParamValue = NULL;
	pPSpiceGetParamValueDbl_t fp_GetParamValueDbl = NULL;
	pPSpiceSetDelay_t fp_setDelay = NULL;					//Digital
	pPSpiceSetConstraint_t fp_setConstraint = NULL;			//Digital
	pPSpiceSetInputSpec_t fp_setInputSpec = NULL;			//Digital
	pPSpiceSetOutputSpec_t fp_setOutputSpec = NULL;			//Digital
	pPSpiceGetInputSpec_t fp_getInputSpec = NULL;			//Digital
	pPSpiceGetOutputSpec_t fp_getOutputSpec = NULL;			//Digital
	pPSpiceGetTimingModelValue_t fp_getTimingValue = NULL;	//Digital
	pPSpiceAddInternalNode_t fp_addInternalNode1 = NULL;
	pPSpiceGetMatrixPtr_t fp_getMatrixPtr = NULL;
	pPSpiceApplyValueItem_t fp_applyValueItem = NULL;
	pPSpiceApplyValueItemComplex_t fp_applyValueItemComplex = NULL;
	pPSpiceGetVoltageNodes_t fp_getV = NULL;
	pPSpiceGetVoltageNodesI_t fp_getVoltageI = NULL;
	pPSpiceGetDelta_t fp_getDelta = NULL;
	pPSpiceGetDeltaPrevious_t fp_getDeltaPrevious = NULL;
	pPSpiceVoltageTolerance_t fp_VoltageTOL = NULL;
	pPSpiceVoltageTolerance_t fp_CurrentTOL = NULL;
	pPSpiceIntegrate_t fp_Integrate = NULL;
	pPSpiceGetCurrentStateIndex_t fp_getStateIndex = NULL;
	//PSPICE_GMINLOAD
	pPSpiceGetFrequency_t fp_getFrequency = NULL;
	descSetInstDataStructSize_t fp_descSetInstDataStructSize = NULL;
	descSetModelDataStructSize_t fp_descSetModelDataStructSize = NULL;
	descSetSignalsStructSize_t fp_descSetSignalsStructSize = NULL;
	descSetStateStructSize_t fp_descSetStateStructSize = NULL;
	descSetReserveNodes_t fp_descSetReserveNodes = NULL;
	descSetAddInternalNodes_t fp_descSetAddInternalNodes = NULL;
	descSetGetMatrixPointers_t fp_descSetGetMatrixPointers = NULL;
	descSetBindTerminals_t fp_descSetBindTerminals = NULL;
	descSetDefaultState_t fp_descSetDefaultState = NULL;
	//PSPICE_SET_MODELPARAMDESC
	descSetStencilStructSize_t fp_descSetStencilStructSize = NULL;
	descSetPreload_t fp_descSetPreload = NULL;
	descSetTranLoad_t fp_descSetTranLoad = NULL;
	descSetAC_Load_t fp_descSetACLoad = NULL;
	descSetTrunc_t fp_descSetTrunc = NULL;
	descSetNoise_t fp_descSetNoise = NULL;
	//PSPICE_SET_GETBREAKPOINT
	pGetBreakPoint_t fp_GetBreakPoint = NULL;
	descSetTmpModModel_t fp_descSetTmpModModel = NULL;
	descSetTmpModDevice_t fp_descSetTmpModDevice = NULL;
	descSetDefaultModel_t fp_descSetDefaultModel = NULL;
	descSetSetModelParams_t fp_descSetSetModelParams = NULL;
	descSetCheckModel_t fp_descSetModChk = NULL;
	descSetDefaultInstance_t fp_descSetDefaultInstance = NULL;
	descSetSetInstanceParams_t fp_descSetSetInstanceParams = NULL;
//-------------------------------------
	//ANALOG
	descSetVersion_t fp_descSetCMIVersion = NULL;
	//DIG
	descSetVersion_t fp_descSetVersion = NULL;
//-----------------------------------------
	descSetName_t fp_descSetName = NULL;
//------------------------------------
	//ANALOG
	//pPSpiceUpdateStateVector_t fp_UpdateSV=NULL;
	//pPSpiceCurrentTErr_t fp_currentTerr=NULL;
	//PSPICE_SET_PRINTDESC
	//DIG
	pPSpiceUpdateStateVector_t fp_UpdateSV=NULL;
	pPSpiceCurrentTErr_t fp_currentTerr=NULL;
	pPrintDescription_t fp_printDescription = NULL;
	//-------------------------------------------------
	descSetSaveCheckpoint_t fp_descSetSaveCheckpoint = NULL;
	descSetLoadCheckpoint_t fp_descSetLoadCheckpoint = NULL;
	descSetSaveTopology_t fp_descSetSaveTopology = NULL;
	descSetCheckTopology_t fp_descSetCheckTopology = NULL;
	descSetDeleteInstance_t fp_descSetDeleteInstance = NULL;
	descSetDeleteModel_t fp_descSetDeleteModel = NULL;
	descSetSetDevicePinCurrent_t fp_descSetSetDevicePinCurrent = NULL;
	descSetSetDevicePinCurrentComplex_t fp_descSetSetDevicePinCurrentComplex = NULL;

	descSetCreateDevice_t fp_descSetCreateDevice = NULL;
	descSetDeleteDevice_t fp_descSetDeleteDevice = NULL;
	descSetGetDeviceTermCount_t fp_descSetGetDeviceTermCount = NULL;
	//--------------------------------------------
	//ANALOG
	//PSPICE_DIG_SETTERMCOUNT
	//PSPICE_DIG_SETTERM
		//PSPICE_DIG_SETPRINTDESC
	//PSPICE_SET_WRITETOOUT
	//PSPICE_DIG_FNCHANGED

	//DIG
	descSetSetDeviceTermCount_t fp_descSetSetDeviceTermCount = NULL;
	descSetSetDeviceTermValue_t fp_descSetSetDeviceTermValue = NULL;
	pDigPrintDescription_t fp_descSetDigPrintDescription = NULL;
	pPSpiceWriteToOut_t fp_PSpiceWriteToOut = NULL;
	pPSpiceChanged_t fp_PSpiceChanged = NULL;
	//---------------------------------------------
    descSetEvaluateDevice_t fp_descSetEvaluateDevice = NULL;
	descSetGetDeviceTermValue_t fp_descSetGetDeviceTermValue = NULL;
	descSetGetDeviceTerminals_t fp_descSetGetDeviceTerminals = NULL;
	descSetSetParameter_t fp_descSetSetParameter = NULL;
		pPSpiceGetTransition_t fp_GetTransition = NULL;
	descSetInitDevice_t fp_descSetInitDevice = NULL;
	pPSpiceSetState_t fp_SetState = NULL;
	pPSpiceGetParameterValue_t fp_GetParameterValue = NULL;
	pGetTimeFromTicks_t fp_getTimeFromTicks = NULL;
	pGetTicksFromTime_t fp_getTicksFromTime = NULL;

	descSetSetTopologySize_t fp_descSetTopologySize = NULL;
	descSetCheckPointSize_t fp_descSetCheckpointSize = NULL;
	pPSpiceGetLicenseString_t fp_getLicenseString = NULL;
	pPSPICEGetOptionsParams_t fp_getOptionParams = NULL;
	pPSpiceAdjustValueItem_t fp_adjustValueItem = NULL;
}

CDLL_FUNC void __cdecl pspiceSetFunctionList(void** pPtr) {
	fp_descSetInstallFunction = (descSetInstallFunction_t)pPtr[PSPICE_SET_INSTALLFUNC];
	fp_setSimTemp = (pPSpiceSetSimulationTemperature_t)pPtr[PSPICE_SET_SIMTEMP];
	fp_descSetProbeTitle = (pPSpiceSetProbeTitle_t)pPtr[PSPICE_SET_PROBETITLE];
	fp_getAnalogTime = (pPSpiceGetCurrentAnalogTime_t)pPtr[PSPICE_GET_ANALOGTIME];
	fp_getDigitalTime = (pPSpiceGetCurrentDigitalTime_t)pPtr[PSPICE_GET_DIGITALTIME];	//Digital
	fp_GetParamValue = (pPSpiceGetParamValue_t)pPtr[PSPICE_GET_PARAMVALUE];
	fp_GetParamValueDbl = (pPSpiceGetParamValueDbl_t)pPtr[PSPICE_GET_PARAMVALUEDBL];

	//ANALOG
		//fp_setDelay = (pPSpiceSetDelay_t)pPtr[PSPICE_SET_DELAY];						//Digital
	//fp_setConstraint = (pPSpiceSetConstraint_t)pPtr[PSPICE_SET_CONSTRAINT];			//Digital
	//fp_setInputSpec = (pPSpiceSetInputSpec_t)pPtr[PSPICE_SET_INSPEC];				//Digital
	//fp_setOutputSpec = (pPSpiceSetOutputSpec_t)pPtr[PSPICE_SET_OUTSPEC];			//Digital
	//fp_getInputSpec = (pPSpiceGetInputSpec_t)pPtr[PSPICE_GET_INSPEC];				//Digital
	//fp_getOutputSpec = (pPSpiceGetOutputSpec_t)pPtr[PSPICE_GET_OUTSPEC];			//Digital
	//fp_getTimingValue = (pPSpiceGetTimingModelValue_t)pPtr[PSPICE_GET_TIMINGVALUE]; //Digital
   
	//DIG
	
	fp_setDelay = (pPSpiceSetDelay_t)pPtr[PSPICE_SET_DELAY];						//Digital
	fp_setConstraint = (pPSpiceSetConstraint_t)pPtr[PSPICE_SET_CONSTRAINT];			//Digital
	fp_setInputSpec = (pPSpiceSetInputSpec_t)pPtr[PSPICE_SET_INSPEC];				//Digital
	fp_setOutputSpec = (pPSpiceSetOutputSpec_t)pPtr[PSPICE_SET_OUTSPEC];			//Digital
	fp_getInputSpec = (pPSpiceGetInputSpec_t)pPtr[PSPICE_GET_INSPEC];				//Digital
	fp_getOutputSpec = (pPSpiceGetOutputSpec_t)pPtr[PSPICE_GET_OUTSPEC];			//Digital
	fp_getTimingValue = (pPSpiceGetTimingModelValue_t)pPtr[PSPICE_GET_TIMINGVALUE]; //Digital

	fp_addInternalNode1 = (pPSpiceAddInternalNode_t)pPtr[PSPICE_ADD_INTERNALNODE];
	fp_getMatrixPtr = (pPSpiceGetMatrixPtr_t)pPtr[PSPICE_GET_MATRIXPTR];
	fp_applyValueItem = (pPSpiceApplyValueItem_t)pPtr[PSPICE_APPLY_VALUEITEM];
	fp_applyValueItemComplex = (pPSpiceApplyValueItemComplex_t)pPtr[PSPICE_APPLY_VALUEITEMCMPLX];
	fp_getV = (pPSpiceGetVoltageNodes_t)pPtr[PSPICE_GET_V];
	fp_getVoltageI = (pPSpiceGetVoltageNodesI_t)pPtr[PSPICE_GET_VI];
	fp_getDelta = (pPSpiceGetDelta_t)pPtr[PSPICE_GET_DELTA];
	fp_getDeltaPrevious = (pPSpiceGetDeltaPrevious_t)pPtr[PSPICE_GET_DELTAPREV];
	fp_VoltageTOL = (pPSpiceVoltageTolerance_t)pPtr[PSPICE_VOLTAGE_TOL];
	fp_CurrentTOL = (pPSpiceVoltageTolerance_t)pPtr[PSPICE_CURRENT_TOL];
	fp_Integrate = (pPSpiceIntegrate_t)pPtr[PSPICE_INTEGRATE];
	fp_getStateIndex = (pPSpiceGetCurrentStateIndex_t)pPtr[PSPICE_GET_STATE];
	//PSPICE_GMINLOAD
	fp_getFrequency = (pPSpiceGetFrequency_t)pPtr[PSPICE_GET_ACFREQUENCY];
	fp_descSetInstDataStructSize = (descSetInstDataStructSize_t)pPtr[PSPICE_SET_INSTDATASTRUCTSIZE];
	fp_descSetModelDataStructSize = (descSetInstDataStructSize_t)pPtr[PSPICE_SET_MODELDATASTRUCTSIZE];
	fp_descSetSignalsStructSize = (descSetSignalsStructSize_t)pPtr[PSPICE_SET_SIGNALSTRUCTSIZE];
	fp_descSetStateStructSize = (descSetStateStructSize_t)pPtr[PSPICE_SET_STATESTRUCTSIZE];
	fp_descSetReserveNodes = (descSetReserveNodes_t)pPtr[PSPICE_SET_RESERVENODES];
	fp_descSetAddInternalNodes = (descSetAddInternalNodes_t)pPtr[PSPICE_SET_ADDINTERNALNODES];
	fp_descSetGetMatrixPointers = (descSetGetMatrixPointers_t)pPtr[PSPICE_SET_GETMATRIXPTR];
	fp_descSetBindTerminals = (descSetBindTerminals_t)pPtr[PSPICE_SET_BINDTERMINALS];
	fp_descSetDefaultState = (descSetDefaultState_t)pPtr[PSPICE_SET_DEFAULTSTATE];
	//PSPICE_SET_MODELPARAMDESC
	fp_descSetStencilStructSize = (descSetStencilStructSize_t)pPtr[PSPICE_SET_STENCILSTRUCTSIZE];
	fp_descSetPreload = (descSetPreload_t)pPtr[PSPICE_SET_PRELOAD];
	fp_descSetTranLoad = (descSetTranLoad_t)pPtr[PSPICE_SET_TRANLOAD];
	fp_descSetACLoad = (descSetAC_Load_t)pPtr[PSPICE_SET_ACLOAD];
	fp_descSetTrunc = (descSetTrunc_t)pPtr[PSPICE_SET_TRUNC];
	fp_descSetNoise = (descSetNoise_t)pPtr[PSPICE_SET_NOISE];
	fp_GetBreakPoint = (pGetBreakPoint_t)pPtr[PSPICE_SET_GETBREAKPOINT];
	fp_descSetTmpModModel = (descSetTmpModModel_t)pPtr[PSPICE_SET_TMPMODMODEL];
	fp_descSetTmpModDevice = (descSetTmpModDevice_t)pPtr[PSPICE_SET_TMPMODDEVICE];
	fp_descSetDefaultModel = (descSetDefaultModel_t)pPtr[PSPICE_SET_DEFMODEL];
	fp_descSetSetModelParams = (descSetSetModelParams_t)pPtr[PSPICE_SET_MODELPARAMS];
	fp_descSetModChk = (descSetCheckModel_t)pPtr[PSPICE_SET_MODCHK];
	fp_descSetDefaultInstance = (descSetDefaultInstance_t)pPtr[PSPICE_SET_DEFINST];
	fp_descSetSetInstanceParams = (descSetSetInstanceParams_t)pPtr[PSPICE_SET_INSTPARAMS];
	
	//ANALOG
	fp_descSetCMIVersion = (descSetVersion_t)pPtr[PSPICE_SET_VERSION];
	//pPSpiceCurrentTErr_t fp_currentTerr;
	//PSPICE_SET_PRINTDESC
	//PSPICE_DIG_SETTERMCOUNT
	//PSPICE_DIG_SETTERM
	//PSPICE_DIG_SETPRINTDESC
	//PSPICE_SET_WRITETOOUT
	//PSPICE_DIG_FNCHANGED

	 //DIGITAL
	fp_descSetVersion = (descSetVersion_t)pPtr[PSPICE_SET_VERSION];
	fp_descSetSetDeviceTermCount = (descSetGetDeviceTermCount_t)pPtr[PSPICE_DIG_SETTERMCOUNT];
	fp_descSetSetDeviceTermValue = (descSetSetDeviceTermValue_t)pPtr[PSPICE_DIG_SETTERM];
	fp_descSetDigPrintDescription = (pDigPrintDescription_t)pPtr[PSPICE_DIG_SETPRINTDESC];			//Digital
	fp_PSpiceWriteToOut = (pPSpiceWriteToOut_t)pPtr[PSPICE_SET_WRITETOOUT];							//Digital
	fp_PSpiceChanged = (pPSpiceChanged_t)pPtr[PSPICE_DIG_FNCHANGED];	
	

    fp_descSetName = (descSetName_t)pPtr[PSPICE_SET_NAME];
	fp_UpdateSV = (pPSpiceUpdateStateVector_t)pPtr[PSPICE_UPDATE_SV];
		fp_descSetSaveCheckpoint = (descSetSaveCheckpoint_t)pPtr[PSPICE_SET_SAVECHECKPT];
	fp_descSetLoadCheckpoint = (descSetLoadCheckpoint_t)pPtr[PSPICE_SET_LOADCHECKPT];
	fp_descSetSaveTopology = (descSetSaveTopology_t)pPtr[PSPICE_SET_SAVETOPOLOGY];
	fp_descSetCheckTopology = (descSetCheckTopology_t)pPtr[PSPICE_SET_CHECKTOPOLOGY];
	fp_descSetDeleteInstance = (descSetDeleteInstance_t)pPtr[PSPICE_SET_DELETEINST];
	fp_descSetDeleteModel = (descSetDeleteModel_t)pPtr[PSPICE_SET_DELETEMODEL];
	fp_descSetSetDevicePinCurrent = (descSetSetDevicePinCurrent_t)pPtr[PSPICE_SET_SETPINI];
	fp_descSetSetDevicePinCurrentComplex = (descSetSetDevicePinCurrentComplex_t)pPtr[PSPICE_SET_SETPINICMPLX];

	//Digital start
	fp_descSetCreateDevice = (descSetCreateDevice_t)pPtr[PSPICE_DIG_CREATEDEVICE];					//Digital
	fp_descSetDeleteDevice = (descSetDeleteDevice_t)pPtr[PSPICE_DIG_DELETEDEVICE];					//Digital
	fp_descSetGetDeviceTermCount = (descSetGetDeviceTermCount_t)pPtr[PSPICE_DIG_GETTERMCOUNT];
	fp_descSetEvaluateDevice = (descSetEvaluateDevice_t)pPtr[PSPICE_DIG_EVALDEVICE];
	fp_descSetGetDeviceTermValue = (descSetGetDeviceTermValue_t)pPtr[PSPICE_DIG_GETTERM];			//Digital
	fp_descSetGetDeviceTerminals = (descSetGetDeviceTerminals_t)pPtr[PSPICE_DIG_GETTERMTYPE];		//Digital
	fp_descSetSetParameter = (descSetSetParameter_t)pPtr[PSPICE_DIG_SETPARAM];	
		fp_GetTransition = (pPSpiceGetTransition_t)pPtr[PSPICE_DIG_FNTRANSITION];						//Digital
	fp_descSetInitDevice = (descSetInitDevice_t)pPtr[PSPICE_DIG_INITDEV];							//Digital
	fp_SetState = (pPSpiceSetState_t)pPtr[PSPICE_DIG_SETSTATE];										//Digital
	fp_GetParameterValue = (pPSpiceGetParameterValue_t)pPtr[PSPICE_DIG_GETPARAMVALUE];				//Digital
	fp_getTimeFromTicks = (pGetTimeFromTicks_t)pPtr[PSPICE_DIG_TICK_FROM_TIME];						//Digital
	fp_getTicksFromTime = (pGetTicksFromTime_t)pPtr[PSPICE_DIG_TIME_FROM_TICK];						//Digital

	fp_descSetTopologySize = (descSetSetTopologySize_t)pPtr[PSPICE_SET_GETTOPOLOGYSIZE];
	fp_descSetCheckpointSize = (descSetCheckPointSize_t)pPtr[PSPICE_SET_CHECKPTSIZE];
	fp_getLicenseString = (pPSpiceGetLicenseString_t)pPtr[PSPICE_GET_LICENSE];
	fp_getOptionParams = (pPSPICEGetOptionsParams_t)pPtr[PSPICE_GET_OPTIONPARAMS];
	fp_adjustValueItem = (pPSpiceAdjustValueItem_t)pPtr[PSPICE_ADJUST_VALUEITEM];
}


char* getModeStr(modeFlags Mode){
	switch (Mode){
	case MDBPDC: return "MDBPDC";
	case MDBPTR: return "MDBPTR";
	case MDDCSW: return "MDDCSW";
	case MDTRAN: return "MDTRAN";
	case MDAC: return "MDAC";
	};
	return "UNKNOWNMODE";
}

char* getInitFlagsStr(initFlags flag){
	switch (flag){
	case INNORM: return "INNORM";
	case ININIT: return "ININIT";
	case INOFF: return "INOFF";
	case INSTV0: return "INSTV0";
	case INTRAN: return "INTRAN";
	case INPRDCT: return "INPRDCT";
	};
	return "UNKNOWNFLAG";
}



	
    



