/**
 *
 * PSpice-DMI Model File Auto-generated by PSpice Model Editor
 *
 */

#ifndef __pspNoiseFilter_H
#define __pspNoiseFilter_H

#include "PSpiceBase.h"

class pspNoiseFilter : public PSpiceModel
{
public:
	pspNoiseFilter();
	~pspNoiseFilter();

	virtual int ModType() const { return 'X'; }
	virtual void SetDefaultModel();
	virtual int ModChk();

	virtual void setParamValue(const char* pName, double pValue);
	virtual void setParamValueStr(const char* pName, const char* pValue);
	double getParamValue(const char* pParamName);

	int mParamGivenInitialized; 
/************************************/
	/* Model params description
    MaxStepSize : Pre-Defined
	 */
/***********************************/

	double MaxStepSize;
	unsigned MaxStepSize_Given :1;


    
};

class pspNoiseFilterDevice : public PSpiceDevice
{
private:
	class pspStateVector
	{
	public:

		enum stateIncrCondition {
			incr0 = 0,
			incr1 = 1,
			decr1 = 2,
			decr2 = 3
		};

		double	x[16 + MSTVCT];
		double	y[MSTVCT];
		int		currentStateIndex;
		stateIncrCondition currentStateIncr;

		pspStateVector()
		{
			for (int i = 0; i < 16 + MSTVCT; i++) {
				x[i] = 0.0;
			}
			y[0] = y[1] = y[2] = y[3] = 0.0;
			currentStateIndex = 0;
			currentStateIncr = incr0;
		}

		stateIncrCondition getStateIncr(int pStateIndex) {
			stateIncrCondition lStateIncr = incr1;
			if (pStateIndex == currentStateIndex)
				lStateIncr = incr0;
			else if (pStateIndex == currentStateIndex - 1
				|| pStateIndex == 3 && currentStateIndex == 0)
				lStateIncr = decr1;
			else if (pStateIndex == currentStateIndex - 2
				|| pStateIndex == 2 && currentStateIndex == 0
				|| pStateIndex == 3 && currentStateIndex == 1)
				lStateIncr = decr2;
			return lStateIncr;
		}

		void adjustState(int pStateIndex){
			double temp[16 + MSTVCT];
			switch (getStateIncr(pStateIndex)) {
			case incr0:
				if (currentStateIncr != incr1){
					memcpy(&temp[0], &x[1], 16U * sizeof(double));
					memcpy(&x[0], &temp[0], 16U * sizeof(double));
				}
				currentStateIncr = incr0;
				break;
			case incr1:
			{
						  for (int i = MSTVCT; i > 0; i--) {
							  x[15 + i] = x[15 + i - 1];
							  y[i - 1] = y[i - 2];
						  }
						  currentStateIncr = incr1;
			}
				break;
			case decr1:
				memcpy(&temp[0], &x[2], 16U * sizeof(double));
				memcpy(&x[0], &temp[0], 16U * sizeof(double));
				y[0] = y[1];
				y[1] = y[2];
				y[2] = y[3];
				currentStateIncr = decr1;
				break;
			case decr2:
				memcpy(&temp[0], &x[3], 16U * sizeof(double));
				memcpy(&x[0], &temp[0], 16U * sizeof(double));
				y[0] = y[2];
				y[1] = y[3];
				currentStateIncr = decr2;
				break;
			};
			currentStateIndex = pStateIndex;
			/*			for(int i=0;i<4;i++)
			printf(" %g ",x[i]);
			printf("\n");*/

		}
	};

public:
	pspNoiseFilterDevice();
	~pspNoiseFilterDevice();
/******************************/
	/* Instance params description
	 */
/*****************************/
	

	pspNoiseFilter* Model() {
		return mModel;
	}

	virtual void setModel(PSpiceModel* pModel) {
		mModel = (pspNoiseFilter*)pModel;
	}

	virtual int DevType() const { return 'y'; }

	virtual int		PinCount() const { return 4; }
	virtual double	IPin(int pin, int mode);
	virtual cmplex	IPinComplex(int pin, double omega);
	virtual void	LoadCheckpointInfo(unsigned int pVersion, void* pStr, size_t pSize);
	virtual void	SaveCheckpointInfo(unsigned int pVersion, void* pStr, size_t pSize);
	virtual void	setParamValue(const char* pName, double pValue);
	virtual void	setParamValueStr(const char* pName, const char* pValue);
	double			getParamValue(const char* pParamName);

	virtual void setNodeName(int i, const char* pNodeName);
	virtual void createMatrixStencil();
	virtual double Trunc();
	virtual void TmpMod(
		double /* ToldK */,
		double /* TnewK */,
		double /* TnomK */);
	virtual int ReserveNodes(PSpiceSignalNodeList* pNodeList);
	virtual void SetDefaultState(PSpiceDeviceMiscInfo* pMiscInfo);

	//load functions
	virtual int Load(int pMode, int pInitFlag, int pLoadFlag, double pTnow);
	virtual void ACLoad(double);
	virtual void ModChk() {}
	virtual int AddInternalNodes(PSpiceDeviceMiscInfo*);

private:

/******************************/
	/* Terminals/Nodes description
	Terminal Input1 : Noise Input 1
	Terminal Input2 : Noise Input 2
	Terminal Output1 : Output 1
	Terminal Output2 : Output 2
	 */
/*****************************/
	char Input1[1024], Input2[1024], Output1[1024], Output2[1024];

	//Internal Node names
	char*  cibr;
	//internal node and out branch current 
	double *ribr;
	double iout;

/******************************/
	/* Global params description
	 */
/*****************************/
	
	// MatPrm indices: conductance terms
	double *Input1_cibr , *cibr_Input1, *Input2_cibr , *cibr_Input2, *Output1_cibr , *cibr_Output1, *Output2_cibr , *cibr_Output2 ;

    //Declare Node conductances
	

	// MatPrm indices: branch currents
	double *rInput1, *rInput2, *rOutput1, *rOutput2;

	// Last iteration values for integration or step back
	pspStateVector sv;

	pspNoiseFilter* mModel;

};

#endif

