/***
*** Interface: pspice 16.6
 *** created by: admsXml-2.3.0 - Mon, 25 Jul 2016 14:36:59 ***/


#include "StdAfx.h"
#include <string>
#include <vector>
#include <map>
#include <utility>
#include "PSpiceBase.h"

#include "pspEngFunc.h"
#include "capdefs.h"

typedef unsigned int unint;


pPSpiceSetSimulationTemperature_t fp_setSimTemp = NULL;
pPSpiceAddInternalNodeByName_t fp_addInternalNode = NULL;
pPSpiceGetMatrixPtr_t fp_getMatrixPtr = NULL;
pPSpiceGetRHSPtr_t fp_getRHSPtr = NULL;
pPSpiceApplyValueItem_t fp_applyValueItem = NULL;
pPSpiceApplyValueItemComplex_t fp_applyValueItemComplex = NULL;
pPSpiceAdjustValueItem_t fp_adjustValueItem = NULL;
pPSpiceGetVoltageNodes_t fp_getV = NULL;
pPSpiceGetVoltageNodesI_t fp_getVoltageI = NULL;
pPSpiceGetDelta_t fp_getDelta = NULL;
pPSpiceGetDeltaPrevious_t fp_getDeltaPrevious = NULL;
pPSpiceVoltageTolerance_t fp_VoltageTOL = NULL;
pPSpiceVoltageTolerance_t fp_CurrentTOL = NULL;
//pGminLoad_t fp_GminLoad = NULL;
pPSpiceGetFrequency_t fp_getFrequency = NULL;
pPSpiceGetParamValue_t fp_GetParamValue = NULL;
pPSpiceGetParamValueDbl_t fp_GetParamValueDbl = NULL;
pPSpiceIntegrate_t fp_Integrate = NULL;
pPSpiceGetCurrentStateIndex_t fp_getStateIndex = NULL;

descSetInstDataStructSize_t fp_descSetInstDataStructSize = NULL;
descSetInstDataStructSize_t fp_descSetModelDataStructSize = NULL;
descSetSignalsStructSize_t fp_descSetSignalsStructSize = NULL;
descSetStateStructSize_t fp_descSetStateStructSize = NULL;
descSetCheckPointSize_t fp_descSetCheckpointSize = NULL;

//PROC_descSetStencilStructSize fp_descSetStencilStructSize = NULL;

descSetReserveNodes_t fp_descSetReserveNodes = NULL;
//descSetModelParamDesc fp_descSetModelParamDesc = NULL;
descSetBindTerminals_t fp_descSetBindTerminals = NULL;
descSetDefaultState_t fp_descSetDefaultState = NULL;
descSetGetMatrixPointers_t fp_descSetGetMatrixPointers = NULL;
descSetAddInternalNodes_t fp_descSetAddInternalNodes = NULL;
descSetPreload_t fp_descSetPreload = NULL;
descSetTranLoad_t fp_descSetTranLoad = NULL;
descSetAC_Load_t fp_descSetACLoad = NULL;
descSetTrunc_t fp_descSetTrunc = NULL;
descSetNoise_t fp_descSetNoise = NULL;
descSetTmpModDevice_t fp_descSetTmpModDevice = NULL;
descSetTmpModModel_t fp_descSetTmpModModel = NULL;
descSetDefaultModel_t fp_descSetDefaultModel = NULL;
descSetSetModelParams_t fp_descSetSetModelParams = NULL;
descSetCheckModel_t fp_descSetModChk = NULL;
descSetDefaultInstance_t fp_descSetDefaultInstance = NULL;
descSetSetInstanceParams_t fp_descSetSetInstanceParams = NULL;
descSetSaveCheckpoint_t fp_descSetSaveCheckpoint = NULL;
descSetLoadCheckpoint_t fp_descSetLoadCheckpoint = NULL;
descSetSaveTopology_t fp_descSetSaveTopology = NULL;
descSetCheckTopology_t fp_descSetCheckTopology = NULL;
descSetDeleteInstance_t fp_descSetDeleteInstance = NULL;
descSetDeleteModel_t fp_descSetDeleteModel = NULL;
descSetSetDevicePinCurrent_t fp_descSetSetDevicePinCurrent = NULL;
descSetSetDevicePinCurrentComplex_t fp_descSetSetDevicePinCurrentComplex = NULL;
descSetSetTopologySize_t fp_descSetTopologySize = NULL; 

descSetVersion_t fp_descSetCMIVersion = NULL;
descSetName_t fp_descSetName = NULL;
pPSpiceUpdateStateVector_t fp_UpdateSV;
pPSpiceCurrentTErr_t fp_currentTerr;
descSetInstallFunction_t fp_descSetInstallFunction = NULL;

#define STATE_VECTOR_SIZE 4
#define NO 0
#define YES 1


PSP_CMI_EXPORT int PSpiceReserveNodes( PSpiceDeviceInst* pInstKnot, PSpiceDeviceMiscInfo* pMiscInfo, PSpiceSignalNodeList* pNodeList) { //, enum PSpiceError* pError ) {
	return 1;
}

PSP_CMI_EXPORT int pDefaultState(PSpiceDeviceInst* pInstKnot, PSpiceDeviceMiscInfo* pMiscInfo) {
	int nDyn = 1 ;
	return 1;
}


PSP_CMI_EXPORT void PSpiceBindTerminals(PSpiceDeviceInst* pInstKnot, PSpiceDeviceMiscInfo* pMiscInfo, int TerminalCount, PSpiceSignalNodeList* pNodeList) {
	PSpiceDevice* dev = (PSpiceDevice*)pInstKnot->mData;
	for(int i= 0; i<TerminalCount; i++) {
		const char* lName = pNodeList->mNodeNames[i];
		dev->setNodeName(i, lName);
	}
}

PSP_CMI_EXPORT void PSpiceDefaultModelcap(PSpiceDeviceModel* pDeviceModel)
{
	pDeviceModel->mData = new capmodel();
}

PSP_CMI_EXPORT void PSpiceDeleteModelcap(PSpiceDeviceModel* pDeviceModel)
{
	capmodel* lModelData = (capmodel*)pDeviceModel->mData;
	delete lModelData;
	lModelData = NULL;
}

PSP_CMI_EXPORT int PSpiceSetModelParams(PSpiceDeviceModel* pDeviceModel, PSpiceCMIParam** pParamList, int pParamCount) {
	PSpiceModel* lModel = (PSpiceModel*)pDeviceModel->mData;
	for(int i=0; i<pParamCount; i++) {
		const PSpiceCMIParam* lParam = pParamList[i];
		double lValue = lParam->Value.Scalar.Real;
		const char* lName = lParam->Desc->Name;
		lModel->setParamValue(lName, lValue);
	}
	return 1;
}

PSP_CMI_EXPORT int PSpiceModChk(PSpiceDeviceModel* pDeviceModel) {
	PSpiceModel* lModel = (PSpiceModel*)pDeviceModel->mData;
	return lModel->ModChk();
}

PSP_CMI_EXPORT int PSpiceSetInstanceParams(void* pDeviceInst, PSpiceCMIParam** pParamList, int pParamCount) {
	PSpiceDeviceInst* lDeviceInst = (PSpiceDeviceInst*)pDeviceInst;
	PSpiceDevice* lDevice = (PSpiceDevice*)lDeviceInst->mData;

	for(int i=0; i<pParamCount; i++) {
		const PSpiceCMIParam* lParam = pParamList[i];
		double lValue = lParam->Value.Scalar.Real;
		const char* lName = lParam->Desc->Name;
		lDevice->setParamValue(lName, lValue);
	}
	return 1;
}

void setModelPtr(PSpiceDevice* pInst, PSpiceModel* pModel);
PSP_CMI_EXPORT void PSpiceDefaultInstancecap(PSpiceDeviceInst* pDeviceInst, PSpiceDeviceMiscInfo* pMiscInfo)
{
	capmodel* lModelData = (capmodel*)pDeviceInst->mModelData->mData;
	pDeviceInst->mData = new capinstance();
	capinstance* lInstData = (capinstance*)pDeviceInst->mData;
	lInstData->capname = pDeviceInst->mInstID;
	lInstData->setModel(lModelData);
	setModelPtr(lInstData, lModelData);
}

PSP_CMI_EXPORT void PSpiceDeleteInstancecap(PSpiceDeviceInst* pDeviceInst)
{
	capinstance* lInstData = (capinstance*)pDeviceInst->mData;
	delete lInstData;
	lInstData = NULL;
}


void CreateDefaultStencil(PSpiceDeviceInst* pInstKnot)                                                                                                                     
{
}

PSP_CMI_EXPORT void PSpiceAddInternalNodes(PSpiceDeviceInst* pInstKnot, PSpiceDeviceMiscInfo* pMiscInfo) {
	PSpiceDevice* lData = (PSpiceDevice*)pInstKnot->mData;
	lData->AddInternalNodes(pMiscInfo);
}

PSP_CMI_EXPORT void pspiceCreateMatrixStencil(PSpiceDeviceInst* pInstKnot) {
	CreateDefaultStencil(pInstKnot);
	PSpiceDevice* lData = (PSpiceDevice*)pInstKnot->mData;
	lData->createMatrixStencil();
}

int getUICFlag() {
	return NO;
}

PSP_CMI_EXPORT int pspicePreLoad(PSpiceDeviceInst* pInstKnot, PSpiceDeviceModel* pModelKnot) {
	return 1;
}

PSP_CMI_EXPORT int pTranInitStep() {
	return 1;

}

PSP_CMI_EXPORT int pTranLoad() {
	return 1;
}

int capload(PSpiceDevice *inModel, PSpiceDeviceMiscInfo *ckt, int CKTmode);
PSP_CMI_EXPORT int pspiceLoad(int ModeFl, int InitFl, int LoadFl, double Tmod, PSpiceDeviceInst* pInstKnot, PSpiceDeviceMiscInfo* pMiscInfo) {
	PSpiceDevice* lData = (PSpiceDevice*)pInstKnot->mData;
    int nonconv  = NO ;     // non-convergence   flag: YES, NO
	lData->initMatrix();
	nonconv = lData->Load(pMiscInfo, ModeFl);	
	return (nonconv);
}

PSP_CMI_EXPORT double pspiceTrunc(PSpiceDeviceInst* pInstKnot) {
	PSpiceDevice* lData = (PSpiceDevice*)pInstKnot->mData;
	return lData->Trunc();
}

PSP_CMI_EXPORT double PSpiceNoise(PSpiceDeviceInst* pInstKnot, double tnow, double Freq, double* ncmps, int pCompsLength)
{
	PSpiceDevice* lData = (PSpiceDevice*)pInstKnot->mData;
	return lData->Noise(tnow, Freq, ncmps, pCompsLength);
}

PSP_CMI_EXPORT void PSpiceTmpModModel(PSpiceDeviceModel* pModelKnot, double Told, double Tnew, double tnom)
{
	PSpiceModel* lData = (PSpiceModel*)pModelKnot->mData;
	lData->TmpMod(Told, Tnew, tnom);
}

PSP_CMI_EXPORT void PSpiceTmpModDevice(PSpiceDeviceInst* pInstKnot, double Told, double Tnew, double tnom, PSpiceDeviceMiscInfo* pInfo)
{
	PSpiceDevice* lData = (PSpiceDevice*)pInstKnot->mData;
	lData->TmpMod(Told, Tnew, tnom);
}

PSP_CMI_EXPORT void pspiceSaveCheckpoints(void* pInstKnot, unsigned int pVersion, void* pStr, size_t pSize) {
	PSpiceDeviceInst* lInstKnot = (PSpiceDeviceInst*)pInstKnot;
	PSpiceDevice* lData = (PSpiceDevice*)lInstKnot->mData;
	FILE* fp = NULL;
	fopen_s(&fp, "temp.tmp", "wb");
	lData->SaveCheckpointInfo(fp, pVersion);
	fclose(fp);

	fopen_s(&fp, "temp.tmp", "rb");
	fread(pStr, pSize, 1, fp);
	fclose(fp);
}

PSP_CMI_EXPORT void pspiceLoadCheckpoints(void* pInstKnot, unsigned int pVersion, void* pStr, size_t pSize) {
	PSpiceDeviceInst* lInstKnot = (PSpiceDeviceInst*)pInstKnot;
	PSpiceDevice* lData = (PSpiceDevice*)lInstKnot->mData;
	FILE* fp = NULL;
	fopen_s(&fp, "temp.tmp", "wb");
	fprintf(fp, "%s", pStr);
	fclose(fp);
	fopen_s(&fp, "temp.tmp", "rb");
	lData->LoadCheckpointInfo(fp, pVersion);
	fclose(fp);
}

PSP_CMI_EXPORT void pspiceSaveTopology(void* pInstKnot, unsigned int pVersion, void* pStr) {
	PSpiceDeviceInst* lInstKnot = (PSpiceDeviceInst*)pInstKnot;
	PSpiceDevice* lData = (PSpiceDevice*)lInstKnot->mData;
	FILE* fp = NULL;
	fopen_s(&fp, "temp.tmp", "wb");
	size_t lSize = lData->SaveTopology(fp, pVersion);
	fclose(fp);

	fopen_s(&fp, "temp.tmp", "rb");
	fread(pStr, lSize, 1, fp);
	fclose(fp);
}

PSP_CMI_EXPORT bool pspiceCheckTopology(void* pInstKnot, unsigned int pVersion, void* pStr) {
	PSpiceDeviceInst* lInstKnot = (PSpiceDeviceInst*)pInstKnot;
	FILE* fp = NULL;
	fopen_s(&fp, "temp.tmp", "wb");
	fprintf(fp, "%s", pStr);
	fclose(fp);

	fopen_s(&fp, "temp.tmp", "rb");
	PSpiceDevice* lData = (PSpiceDevice*)lInstKnot->mData;
	bool lStatus = lData->CheckTopology(fp, pVersion);
	fclose(fp);

	return lStatus;
}

PSP_CMI_EXPORT size_t PSpiceSetTopologySize(void* pInstKnot, unsigned int pVersion) {
	PSpiceDeviceInst* lInstKnot = (PSpiceDeviceInst*)pInstKnot;
	PSpiceDevice* lData = (PSpiceDevice*)lInstKnot->mData;
	return lData->getTopologySize(pVersion);
}

PSP_CMI_EXPORT double PSpiceSetDevicePinCurrent(PSpiceDeviceInst* pInstKnot, int pin, int mode) {
	// Not supported
	return 0;
}

PSP_CMI_EXPORT void PSpiceSetDevicePinCurrentComplex(PSpiceDeviceInst* pInstKnot, int pin, double omega, double& pCurrentReal, double& pCurrentImag) {
	// Not supported
	pCurrentReal = 0;
	pCurrentImag = 0;
}

PSP_CMI_EXPORT void pspiceSetFunctionList(void** pPtr) {
	fp_setSimTemp = (pPSpiceSetSimulationTemperature_t)pPtr[PSPICE_SET_SIMTEMP];

	fp_addInternalNode		= (pPSpiceAddInternalNodeByName_t)	pPtr[PSPICE_ADD_INTERNALNODEBYNAME];
	fp_getMatrixPtr			= (pPSpiceGetMatrixPtr_t)		pPtr[PSPICE_GET_MATRIXPTR];
	fp_getRHSPtr			= (pPSpiceGetRHSPtr_t)		pPtr[PSPICE_GET_RHSPTR];
	fp_applyValueItem		= (pPSpiceApplyValueItem_t)	pPtr[PSPICE_APPLY_VALUEITEM];
	fp_applyValueItemComplex= (pPSpiceApplyValueItemComplex_t) pPtr[PSPICE_APPLY_VALUEITEMCMPLX];
	fp_getV					= (pPSpiceGetVoltageNodes_t)	pPtr[PSPICE_GET_V];
	fp_getVoltageI			= (pPSpiceGetVoltageNodesI_t)	pPtr[PSPICE_GET_VI];
	fp_getDelta				= (pPSpiceGetDelta_t)			pPtr[PSPICE_GET_DELTA];
	fp_getDeltaPrevious		= (pPSpiceGetDeltaPrevious_t) pPtr[PSPICE_GET_DELTAPREV];
	fp_VoltageTOL			= (pPSpiceVoltageTolerance_t)				pPtr[PSPICE_VOLTAGE_TOL];
	fp_CurrentTOL			= (pPSpiceVoltageTolerance_t)				pPtr[PSPICE_CURRENT_TOL];
	fp_Integrate			= (pPSpiceIntegrate_t)				pPtr[PSPICE_INTEGRATE];
	fp_getStateIndex		= (pPSpiceGetCurrentStateIndex_t) pPtr[PSPICE_GET_STATE];
	fp_getFrequency			= (pPSpiceGetFrequency_t)		pPtr[PSPICE_GET_ACFREQUENCY];
	fp_GetParamValue		= (pPSpiceGetParamValue_t)	pPtr[PSPICE_GET_PARAMVALUE];
	fp_GetParamValueDbl		= (pPSpiceGetParamValueDbl_t) pPtr[PSPICE_GET_PARAMVALUEDBL];
	fp_descSetInstDataStructSize = (descSetInstDataStructSize_t) pPtr[PSPICE_SET_INSTDATASTRUCTSIZE];
	fp_descSetModelDataStructSize=	(descSetInstDataStructSize_t) pPtr[PSPICE_SET_MODELDATASTRUCTSIZE];
	fp_descSetSignalsStructSize = (descSetSignalsStructSize_t)	pPtr[PSPICE_SET_SIGNALSTRUCTSIZE];
	fp_descSetStateStructSize	= (descSetStateStructSize_t)	pPtr[PSPICE_SET_STATESTRUCTSIZE];
	fp_descSetReserveNodes		= (descSetReserveNodes_t)		pPtr[PSPICE_SET_RESERVENODES];
	fp_descSetAddInternalNodes	= (descSetAddInternalNodes_t)	pPtr[PSPICE_SET_ADDINTERNALNODES];
	fp_descSetGetMatrixPointers	= (descSetGetMatrixPointers_t)	pPtr[PSPICE_SET_GETMATRIXPTR];
	fp_descSetBindTerminals		= (descSetBindTerminals_t)		pPtr[PSPICE_SET_BINDTERMINALS];
	fp_descSetDefaultState		= (descSetDefaultState_t)		pPtr[PSPICE_SET_DEFAULTSTATE];
	fp_descSetPreload			= (descSetPreload_t)			pPtr[PSPICE_SET_PRELOAD];
	fp_descSetTranLoad			= (descSetTranLoad_t)			pPtr[PSPICE_SET_TRANLOAD];
	fp_descSetACLoad			= (descSetAC_Load_t)			pPtr[PSPICE_SET_ACLOAD];
	fp_descSetTrunc				= (descSetTrunc_t)				pPtr[PSPICE_SET_TRUNC];
	fp_descSetNoise				= (descSetNoise_t)				pPtr[PSPICE_SET_NOISE];
	fp_descSetTmpModModel		= (descSetTmpModModel_t)		pPtr[PSPICE_SET_TMPMODMODEL];
	fp_descSetTmpModDevice		= (descSetTmpModDevice_t)		pPtr[PSPICE_SET_TMPMODDEVICE];

	fp_descSetDefaultModel		= (descSetDefaultModel_t)		pPtr[PSPICE_SET_DEFMODEL];
	fp_descSetSetModelParams	= (descSetSetModelParams_t)		pPtr[PSPICE_SET_MODELPARAMS];
	fp_descSetModChk			= (descSetCheckModel_t)			pPtr[PSPICE_SET_MODCHK];
	fp_descSetDefaultInstance	= (descSetDefaultInstance_t)	pPtr[PSPICE_SET_DEFINST];
	fp_descSetSetInstanceParams	= (descSetSetInstanceParams_t)	pPtr[PSPICE_SET_INSTPARAMS];

	fp_descSetCMIVersion		= (descSetVersion_t)			pPtr[PSPICE_SET_VERSION];
	fp_descSetName				= (descSetName_t)				pPtr[PSPICE_SET_NAME];

	fp_UpdateSV					= (pPSpiceUpdateStateVector_t)	pPtr[PSPICE_UPDATE_SV];
	fp_currentTerr				= (pPSpiceCurrentTErr_t)		pPtr[PSPICE_CURRENT_TERR];

	fp_descSetSaveCheckpoint	= (descSetSaveCheckpoint_t)		pPtr[PSPICE_SET_SAVECHECKPT];
	fp_descSetLoadCheckpoint	= (descSetLoadCheckpoint_t)		pPtr[PSPICE_SET_LOADCHECKPT];
	fp_descSetSaveTopology		= (descSetSaveTopology_t)		pPtr[PSPICE_SET_SAVETOPOLOGY];
	fp_descSetCheckTopology		= (descSetCheckTopology_t)		pPtr[PSPICE_SET_CHECKTOPOLOGY];

	fp_descSetInstallFunction	= (descSetInstallFunction_t)	pPtr[PSPICE_SET_INSTALLFUNC];

	fp_descSetDeleteInstance	= (descSetDeleteInstance_t)		pPtr[PSPICE_SET_DELETEINST];
	fp_descSetDeleteModel		= (descSetDeleteModel_t)		pPtr[PSPICE_SET_DELETEMODEL];

	fp_descSetSetDevicePinCurrent = (descSetSetDevicePinCurrent_t)	pPtr[PSPICE_SET_SETPINI];
	fp_descSetSetDevicePinCurrentComplex = (descSetSetDevicePinCurrentComplex_t)	pPtr[PSPICE_SET_SETPINICMPLX];

	fp_descSetCheckpointSize	= (descSetCheckPointSize_t)		pPtr[PSPICE_SET_CHECKPTSIZE];
	fp_descSetTopologySize		= (descSetSetTopologySize_t)		pPtr[PSPICE_SET_GETTOPOLOGYSIZE];
	fp_adjustValueItem = (pPSpiceAdjustValueItem_t) pPtr[PSPICE_ADJUST_VALUEITEM];
}

PSP_CMI_EXPORT int pspiceACLoad(PSpiceDeviceInst* pInstKnot, double pFreq)
{
/*****************************************************************************
* Purpose
*   Process Device models for AC analysis
*
* Returned value
*   None

*****************************************************************************/

	PSpiceDevice* lData = (PSpiceDevice*)pInstKnot->mData;

	double G = 0; /* Conductance */
	double Omega = fp_getFrequency();             /* 2*pi*frequency                      */

	lData->initMatrix();
	lData->ACLoad(pFreq);
	return 0;
} /* End q_ACLoad */


void setCommonAPIs(void* pRef) {
	//Common functions
	fp_descSetSetInstanceParams(pRef, &PSpiceSetInstanceParams);
	fp_descSetSetModelParams(pRef, &PSpiceSetModelParams);

	fp_descSetBindTerminals(pRef, &PSpiceBindTerminals);
	fp_descSetReserveNodes(pRef, &PSpiceReserveNodes);
	fp_descSetAddInternalNodes(pRef, &PSpiceAddInternalNodes);
	fp_descSetGetMatrixPointers(pRef, &pspiceCreateMatrixStencil);
	fp_descSetPreload(pRef, &pspicePreLoad);
	
	fp_descSetACLoad(pRef, &pspiceACLoad);
	fp_descSetTranLoad(pRef, &pspiceLoad);
	fp_descSetTrunc(pRef, &pspiceTrunc);
	fp_descSetNoise(pRef, &PSpiceNoise);
	fp_descSetTmpModDevice(pRef, &PSpiceTmpModDevice);
	fp_descSetTmpModModel(pRef, &PSpiceTmpModModel);

	fp_descSetSaveCheckpoint(pRef, &pspiceSaveCheckpoints);
	fp_descSetLoadCheckpoint(pRef, &pspiceLoadCheckpoints);
	fp_descSetSaveTopology(pRef, &pspiceSaveTopology);
	fp_descSetCheckTopology(pRef, &pspiceCheckTopology);
	fp_descSetTopologySize(pRef, &PSpiceSetTopologySize);

	fp_descSetDefaultState(pRef, &pDefaultState);
	fp_descSetSetDevicePinCurrent(pRef, &PSpiceSetDevicePinCurrent);
	fp_descSetSetDevicePinCurrentComplex(pRef, &PSpiceSetDevicePinCurrentComplex);
}

void installcap(void* pRef) {
	fp_descSetCMIVersion(pRef, "1.2");
	char lModuleName[] = "cap";
	fp_descSetName(pRef, pspUpperCase(lModuleName));
	fp_descSetModelDataStructSize(pRef, sizeof(capmodel));
	fp_descSetInstDataStructSize(pRef,  sizeof(capinstance));
	fp_descSetDefaultModel(pRef, &PSpiceDefaultModelcap);
	fp_descSetModChk(pRef, &PSpiceModChk);

	fp_descSetDefaultInstance(pRef, &PSpiceDefaultInstancecap);
	fp_descSetDeleteInstance(pRef, &PSpiceDeleteInstancecap);
	fp_descSetDeleteModel(pRef, &PSpiceDeleteModelcap);

  setCommonAPIs(pRef);
  }

PSP_CMI_EXPORT void PSpiceInstallFunction() {
  fp_descSetInstallFunction(&installcap);
  }


  void adjustCurrentItem(PSpiceDevice* pDev, int pNode, double v) {
  double* ptr = pDev->getRHS(pNode);
	if(ptr) 
		fp_adjustValueItem( ptr, v);
}

double getCurrentItem(PSpiceDevice* pDev, int pNode) {
	double* myPtr =  pDev->getRHS(pNode);
	if(myPtr)
		return *myPtr;
	else
		return 0;
}

double getCurrentItemI(PSpiceDevice* pDev, int pNode) {
	double* myPtr =  pDev->getRHS(pNode) + 1;
	if(myPtr)
		return *myPtr;
	else
		return 0;
}

int psIntegrate(capinstance* pDev, double* geq,double* ieq, double cap_val, int state0) {
	qi_def* qi0 =  (qi_def*)(pDev->states0 + state0);
	qi_def* qi1 = (qi_def*)(pDev->states1 + state0);
	qi_def* qi2 = (qi_def*)(pDev->states1 + state0);

	fp_Integrate(*geq, *ieq, cap_val, *qi0, *qi1, *qi2, ININIT);

	return 0;
}

int psTrunc(capinstance* pDev, int state0, double& timestep) {
	qi_def* qi0 =  (qi_def*)(pDev->states0 + state0);
	qi_def* qi1 = (qi_def*)(pDev->states1 + state0);
	qi_def* qi2 = (qi_def*)(pDev->states1 + state0);

	timestep = fp_currentTerr(qi0, qi1, qi2, qi2, NULL);
	return 0;
}

